#!/bin/sed -nf

# mail-dom-addr.sed -- parse mbox-style files for 'from' and relay
# lines.  Used in blacklist generator.


# First line -- start already
1{
   b from
}

# A sed script with a main loop.  Yep.
:main

# Quit on EOF
$q

/^$/{
    n
    # Start of headers
    :from
    # /^From /,/^$/{
    1,/^$/{
	:header
	# strip tags and quoting symbols
	/[][<>"]/s///g

	# Filters:
	# ...domains
	/^Received:/{
	    /^.* \([A-Za-z][A-Za-z0-9]*\.[A-Za-z0-9][A-Za-z0-9\.]*\.[A-Za-z]*\) .*/s//d: \1/p
	}
	# ...addresses
	/^[Ff][Rr][Oo][Mm]:[ 	][ 	]*/{
	    /^[Ff][Rr][Oo][Mm]:*/s///
	    /^ */s///
	    /^[^@]* /s///
	    / [^@]*$/s///
	    / .*/s///
	    /mailto:/s///
	    /.*/s//a: &/p
	}
	/^$/b main
	# Get another line and do it again.
	n
	b header
    } 
}
# Get another line and do it again.
n
b main
